global delta om E omf tf;

om=10;    % frequency of oscillator
delta=0.3;  % strength of instability in oscillator
wI=0.01;  % initial condition

omf=25; % control frequency
tf=50;  % time at which control is switched on

Ec=sqrt(4*delta)*abs(omf^2-om^2) % theoretical forcing amplitude to stabilize oscillator

%E=0;
%E=300;
%E=500;
%E=550;
%E=575;
E=600

dt=1e-2;  % sampling time
[T,Y]=ode45(@yfdot,[0:dt:200],[wI; 0]);

figure(1) % Time-behavior
plot(T,Y(:,1),'r')
hold off;

figure(2) % Phase diagram
plot(Y(1:tf/dt,1),Y(1:tf/dt,2),'b')
hold on;
plot(Y(tf/dt:end,1),Y(tf/dt:end,2),'r')
hold off;

Fs=1./dt; % sampling frequency
figure(3) % Fourier spectra of unforced and forced oscillator
[spectra,freq]=pwelch(Y(1:tf/dt,1),1000,0.5,1000,Fs); % Octave
plot(freq(1:501)*3.14*2,abs(spectra(1:501)),'b'); % Octave
%[spectra,freq]=pwelch(Y(1:tf/dt,1),1000,500,1000,Fs); % Matlab
%plot(freq(1:501),abs(spectra(1:501)),'b'); % Matlab
hold on;
[spectra,freq]=pwelch(Y(tf/dt:end,1),1000,0.5,1000,Fs); % Octave
plot(freq(1:501)*3.14*2,abs(spectra(1:501)),'r'); % Octave
%[spectra,freq]=pwelch(Y(tf/dt:end,1),1000,500,1000,Fs); % Matlab
%plot(freq(1:501),abs(spectra(1:501)),'r'); % Matlab
hold off;